program SDMCReadParamDirect;


(*{$DEFINE COPROC}
{$IFDEF COPROC}
{$N+}
{$ELSE}
{$N-}
{$ENDIF} *)

{$IFDEF WINDOWS}
uses synaser,synautil,synaip,blcksock,dos,crt;
var
ser:TBlockSerial;
TheComPort : string;
IPAddr : string;
Socket : TUDPBlockSocket;
{$ELSE}
uses dos,crt;
var TheComPort : word;
{$ENDIF}

{DEFINE DEBUG}
{DEFINE SERDEBUG}
{DEFINE DSPIC} { for 3C20 }
{DEFINE SEVENI64} { for 7I64 }
{DEFINE EIGHTI20} { for 8I20 }
{DEFINE WINDOWS}

{$I SELECTC}
{$I SELECTIO}
{SELECTP}
{$I SELECTPR}
{$I INTERFCE}

var
i,j : longint;
Parameter : longint;
LongData : longint;
WordData : word;
IntData : integer;
ByteData : byte;
ByteLoc : byte;
Bigdata : comp;
Retcode : integer;
UseHex : boolean;
DoRepeat : boolean;
GetAddress : boolean;
temp : word;
ParmLoc : integer;
ParmName : string;
c : char;

var
Parmtype : ParameterType;

procedure FixCRT;
{ Fix re-direction when using CRT unit }
begin
  assign(input,'');
  reset(input);
  assign(output,'');
  rewrite(output);
end;

procedure Error(err : integer);
begin
  writeln(errorrecord[err].errstr);
  halt(2);
end;

procedure Usage;
begin
  writeln('Usage: rp parm [axis] [q] [h] [r] [a]');
  writeln;
  halt(2);
end;

function FindParm(aname : string) : boolean;
var
index : integer;
cname : string;
offset : word;
retcode : integer;
begin
  cname := StripTillChar(aname,'+');
  offset := 0;
  if length(aname) >0 then
  begin
    val(aname,offset,retcode);
    if retcode <> 0 then BumOut('Can''t parse offset');
  end;
  index := 1;
  while (upstring(cname) <> upstring(SDMCParams[index].ParmName)) and (index <= LastParm) do index := index +1;
  ParmLoc := SDMCParams[index].ParmLoc + offset;
  ParmType := SDMCParams[index].ParmType;
  ParmName := SDMCParams[index].ParmName; {so it will have the cannonical name}
  if index > LastParm then FindParm := false else findparm := true;
end;

procedure Pause;
var foo : string;
begin
  writeln;
  writeln('Press return to continue');
  readln(foo);
end;

procedure ShowParameters(s : string);
var index,lc : integer;
begin
  writeln('No such parameter: '+s);
  writeln('Valid parameters are: ');
  lc := 0;
  for index := 1 to LastParm do
  begin
    if (index mod 4) = 0 then
    begin
      writeln;
      lc := lc +1;
    end;
    if lc > 19 then
    begin
      Pause;
      lc := 0;
    end;
    write(PadWithSpaces(SDMCParams[index].ParmName,19));
  end;
  writeln;
  halt(2);
end;

procedure GetParameter;
var
index : word;
hstring,nstring : string;
begin
  UseHex := false;
  DoRepeat := false;
  GetAddress := false;
  for index := 2 to 5 do
  begin
    if length(ParamStr(index)) > 0 then
    begin
      if upstring(ParamStr(index)) = 'H' then UseHex := true;
      if upstring(ParamStr(index)) = 'R' then DoRepeat := true;
      if upstring(ParamStr(index)) = 'A' then GetAddress := true;
    end;
  end;

  if length(ParamStr(1)) = 0 then Usage;
  if not FindParm(ParamStr(1)) then ShowParameters(ParamStr(1));
  Axis := 0;
  if length(ParamStr(2)) > 0 then
  begin
    val(ParamStr(2),temp,Retcode);
    if retcode = 0 then Axis := temp;
  end;
end;  { GetParameter }

begin
  FixCrt;
  GetParameter;
  GetOurEnv;
  Message := 'Setup Mode';
  if not InitializeInterface(Message) then bumout(Message);
  if GetAddress then
  begin
    Write('Parm address: ');
    HexPrint(ParmLoc,4);
    writeln;
  end;
  if parmtype = type_byte then
  begin
    repeat
      ByteData := ReadByte(ParmLoc);
      if UseHex then
      begin
        write('Data ');
        HexPrint(ByteData,2);
        writeln;
      end
      else writeln('Data ',ByteData:3);
      delay(1);
    until (not DoRepeat) or KeyPressed
  end;

  if (parmtype = type_uint) or (parmtype = type_ptr) or (parmtype = type_mask) or (parmtype = type_flag) then
  begin
    repeat
      WordData := ReadWord(ParmLoc);
      if UseHex then
      begin
        write('Data ');
        HexPrint(WordData,4);
        writeln;
      end
      else writeln('Data ',WordData:5);
      delay(1);
    until (not DoRepeat) or KeyPressed
  end;

  if (parmtype = type_int) then
  begin
    repeat
      IntData := ReadWord(ParmLoc);
      if UseHex then
      begin
        write('Data ');
        HexPrint(IntData,4);
        writeln;
      end
      else writeln('Data ',IntData:5);
  until (not DoRepeat) or KeyPressed
  end;

  if (ParmType = type_ulong) or (ParmType = type_long) then
  begin
    repeat
    LongData := ReadLong(ParmLoc);
      if UseHex then
      begin
        write('Data ');
        HexPrint(LongData,8);
        writeln;
      end
      else writeln('Data ',LongData:10);
    until (not DoRepeat) or KeyPressed
  end;

  if (ParmType = type_double) then
  begin
    repeat  Bigdata := ReadDouble(ParmLoc);
      if SerError then bumout('Serial Timeout Error');
      if UseHex then
      begin
        write('Data ');
        HexPrint(DoubleLongRec(BigData).Long1,8);
        HexPrint(DoubleLongRec(BigData).Long0,8);
        writeln;
      end
      else writeln('Data ',BigData:20:0);
    until (not DoRepeat) or KeyPressed
  end;

  if (ParmType = type_triple) then
  begin
    repeat
      begin
        Bigdata := ReadDouble(ParmLoc);
        LongData := ReadLong(ParmLoc+8);
      end;
      if SerError then bumout('Serial Timeout Error');
      if UseHex then
      begin
        write('Data ');
        HexPrint(LongData,8);
        HexPrint(DoubleLongRec(BigData).Long1,8);
        HexPrint(DoubleLongRec(BigData).Long0,8);
        writeln;
      end
      else writeln('Use HEX');
    until (not DoRepeat) or KeyPressed
  end;
{$IFNDEF SEVENI64}
{IFNDEF EIGHTI20}

  if ParmType = type_elong then
  begin
    repeat
    LongData := ReadEEPROMLong(ParmLoc);
      if UseHex then
      begin
        write('Data ');
        HexPrint(LongData,8);
        writeln;
      end
      else writeln('Data ',LongData:10);
    until (not DoRepeat) or KeyPressed
  end;
{ENDIF}

  if ParmType = type_eword then
  begin
    repeat
    WordData := ReadEEPROMWord(ParmLoc);
      if UseHex then
      begin
        write('Data ');
        HexPrint(WordData,4);
        writeln;
      end
      else writeln('Data ',WordData:5);
    until (not DoRepeat) or KeyPressed
  end;

  if ParmType = type_ebyte then
  begin
    repeat
    WordData := ReadEEPROMByte(ParmLoc);
      if UseHex then
      begin
        write('Data ');
        HexPrint(WordData,2);
        writeln;
      end
      else writeln('Data ',WordData:3);
    until (not DoRepeat) or KeyPressed
  end;
{$ENDIF}

  if SerError then bumout('Serial Timeout Error');
  halt(0);
end.
